<?php
require_once("utils.inc.php");
/* these of course work. */
$mysqli = GetMySQLiObject();
StartUp($mysqli);

/*TODO : finish Tests in this section */
try { 
	//IterateLibraryDirectory($mysqli, "./Library", "AddEntryToDatabase"); // works works works!
}
catch(Exception $ex) { 
	trigger_error($ex->getMessage(), E_USER_ERROR);
}

// FileTreeLibraryJSONResponse($mysqli); // works works works!

// BuildCumulativeKeywordGraph($mysqli); // works!

//CumulativeKeywordsJSONResponse($mysqli); // works works works!

//SelectCumulativeKeywordsHTMLResponse($mysqli); // perhaps deprecated, atleast for now.

//StoreSelectedKeywords($mysqli, array(2, 20, 7, 41, 56)); //// perhaps deprecated, atleast for now.

//LibrarySortedByKeywordsJSONResponse($mysqli); // perhaps deprecated, atleast for now.

/* end of test section */

if(isset($_GET["storeKeywords"]) && $_GET["storeKeywords"] == "yes") { 
	//StoreSelectedKeywords($mysqli, $_POST);

}
else if(isset($_GET["getEntireFileTree"]) && $_GET["getEntireFileTree"] == "yes") { 
	 FileTreeLibraryJSONResponse($mysqli);
}
else if(isset($_GET["getSortedFileTree"]) && $_GET["getSortedFileTree"] == "yes") { 
	CumulativeKeywordsJSONResponse($mysqli);
}
else if(isset($_GET["extractAndSetupChm"]) && $_GET["extractAndSetupChm"] == "yes") { 
	CHMExtractionJSONResponse($mysqli);
}

/* */
function GetMySQLiObject() { 
	require('config.inc.php');
        $mysqli = new mysqli(
		$mysql_hostname,
                $mysql_username,
                $mysql_password,
                $mysql_database);
        if (mysqli_connect_errno()) {
		printf("Connect failed: %s\n", 
			mysqli_connect_error());
		exit();
	}
	return($mysqli);
}
/* */
function StartUp($mysqli) { 
	$mysqli->query("
		CREATE TABLE IF NOT EXISTS
		`al_filetree_index` (
		`id` BIGINT NOT NULL AUTO_INCREMENT ,
		`filepath` TEXT NOT NULL ,
		`filetype` VARCHAR( 10 ) NOT NULL ,
		`ctime` DATETIME NOT NULL ,
		`directory` TINYINT NOT NULL DEFAULT '0',
		`modified` TIMESTAMP NOT NULL DEFAULT 
		CURRENT_TIMESTAMP 
		COMMENT 'Row modification timestamp, 
		not to be confused with fs descriptor modification 
		timestamp',
		PRIMARY KEY ( `id` ) ,
		INDEX ( `id` )) ENGINE = MYISAM");
	$mysqli->query("
		CREATE TABLE IF NOT EXISTS 
		`al_filetree_keywords` (
		`id` BIGINT NOT NULL AUTO_INCREMENT,
		`keyword` VARCHAR( 255 ) NOT NULL ,
		`modified` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ,
		INDEX ( `id` )) ENGINE = MYISAM");
	$mysqli->query("
		CREATE TABLE IF NOT EXISTS 
		`al_filetree_keyword_linkage` (
		`id` BIGINT NOT NULL AUTO_INCREMENT,
		`filetree_id` BIGINT NOT NULL ,
		`keyword_id` BIGINT NOT NULL ,
		`modified` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP 
		INDEX (`id` )) ENGINE = MYISAM");
	$mysqli->query("
		CREATE TABLE IF NOT EXISTS
		`al_keyword_cumulative_graph` (
		`id` BIGINT NOT NULL AUTO_INCREMENT,
		`keyword` VARCHAR( 255 ) NOT NULL ,
		`filetreeid` BIGINT NOT NULL ,
		`modified` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ,
		INDEX ( `id` ) ) ENGINE = MYISAM");
}
/* TODO: 
 * - ctime on directories should be useful for
 * determining whether or not the cached filetree
 * that will be stored in SQL is up-to-date.
 *- Add archive filetypes? 
 */

function AddEntryToDatabase(
	$mysqli, 
	$entryName, 
	$fileType,
	$ctime) {
		$t = 1;
		if($fileType == "dir") { 
			$query = "
				INSERT INTO al_filetree_index(filepath, ctime, directory) 
				VALUES ( ?, ?, ? )
			";
			if(!$stmt = $mysqli->prepare($query))
				trigger_error("addentrytodatabase: the worms are getting me qq", E_USER_ERROR);
			
			$stmt->bind_param("ssi",$entryName, date('Y-m-d H:i:s', $ctime), $t);
		}
		else {
			$query = "
				INSERT INTO al_filetree_index(filepath, filetype, ctime) 
				VALUES ( ?, ?, ? )
			";	
			if(!$stmt = $mysqli->prepare($query))
				trigger_error("addentrytodatabase: the worms are getting me rr", E_USER_ERROR);
			$stmt->bind_param("sss", $entryName, $fileType, date('Y-m-d H:i:s', $ctime));
		}
		$stmt->execute();
		return(TRUE);
}

/* */
function CHMExtractionJSONResponse(
	$mysqli,
	$filterExpression = FALSE) {
		$ret = array();
		if(!$filterExpression) {
			$query = "
				SELECT filepath
				FROM al_filetree_index 
				WHERE filepath = ? AND filetype = 'chm'
				LIMIT 1
			";
		}
		if(!$stmt = $mysqli->prepare($query))
			trigger_error("CHMExtractionJSONResponse SQL error", E_USER_ERROR);
		$stmt->bind_param("s", $_REQUEST["bookname"]);
		$stmt->execute();
		$stmt->bind_result($filepath);
		while($stmt->fetch()) { 
			$newdir = "chmExtracts/";
			$newdir .= str_replace("+", "PLUS", str_replace(".", "DOT", str_replace("/", "WHACK", str_replace(" ", "SPACE", $filepath))));
			if(!is_dir($newdir))
				mkdir($newdir);
			exec("extract_chmLib \"".$filepath."\" ".$newdir, $output);
			$bookname = explode("/", $_REQUEST["bookname"]);
			$bookname = $bookname[count($bookname)-1];
			array_push($ret,
				array(
					"extractedChmDir" => $newdir,
					"extractorOutput" => $output,
					"extractorParams" => "extract_chmLib ".$filepath." ".$newdir,
					"bookname" => $bookname,
				));
			echo(json_encode($ret));
			exit();
		}

}
/* */
function FileTreeLibraryJSONResponse(
	$mysqli, 
	$filterExpression = FALSE) {
		$ret = array();
		if(!$filterExpression) {
			$query = "
				SELECT id, filepath, filetype 
				FROM al_filetree_index 
				WHERE directory = 0
			";
		}
		if(!$stmt = $mysqli->prepare($query)) 
			trigger_error("FileTreeLibraryJSONResponse SQL error", E_USER_ERROR);

		$stmt->execute();
		$stmt->bind_result(
			$id,
			$filepath,
			$filetype
		);
		while ($stmt->fetch()) {	
			array_push(
				$ret,
				array(
					"id" => $id,
					"filepath" => $filepath,
					"filetype" => $filetype));
		}
		echo json_encode($ret);
		exit();
}
/* */
function ParseKeyword($keyword) { 
	//TODO 
	//check for things like if its a dictionary word or if its a name like a name of a technology 
	//lower it
	//strip weird characters
	//throw exceptions on words we don't ever want to use like "the" or "is" or weird stuff, possibly optionally at some point.
	return(strtolower($keyword));
}
/*
SELECT kcg.id, COUNT( kcg.keyword ) , kcg.filetreeid field_for_display_only_filetreeid, kcg.keyword, kcg.modified
FROM al_keyword_cumulative_graph kcg
GROUP BY kcg.keyword
ORDER BY COUNT( kcg.keyword ) DESC

*/

/* */
function BuildCumulativeKeywordGraph(
	$mysqli,
	$filterExpression = FALSE) { 
		$keywords = array();
		if(!$filterExpression) {
			$query = '
				select 
				fti.id, 
				REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(fti.filepath,"./", " "), "/", " "), ".chm", ""), ".pdf", ""), "Library ", "") sanitized, 
				fti.filetype from al_filetree_index fti 
				WHERE fti.filetype != ""
			';
		}
		if(!$stmt = $mysqli->prepare($query)) 
			trigger_error("BuildCumulativeKeywordGraph SQL error", E_USER_ERROR);

		$stmt->execute();
		$stmt->bind_result(
			$id, $sanitized, $filetype
		);
		while ($stmt->fetch()) {
			array_push($keywords, array("id" => $id, "keywords" => explode(" ", $sanitized), "filetype" => $filetype));
		}
		foreach($keywords as $rows) { 
			foreach($rows["keywords"] as $keyword) { 
				//AddOrIncrementCumulativeKeyword($mysqli, $keyword);
				$query = '
					INSERT into al_keyword_cumulative_graph (keyword, filetreeid)
					VALUES ( ?, ? )
				';
				if(!$stmt = $mysqli->prepare($query)) 
					trigger_error("BuildCumulativeKeywordGraph SQL error", E_USER_ERROR);
				$stmt->bind_param("si", $keyword, $rows["id"]);
				$stmt->execute();
			}
		}
		exit();
}
/* */
function CumulativeKeywordsJSONResponse(
	$mysqli, 
	$filterExpression = FALSE) {
		$ret = array();
		if(!$filterExpression) {
			$query = '
				SELECT COUNT( kcg.keyword ) , kcg.keyword
				FROM al_keyword_cumulative_graph kcg
				JOIN al_filetree_index fti ON fti.id = kcg.filetreeid
				WHERE kcg.keyword != ""
				GROUP BY kcg.keyword
				ORDER BY COUNT( kcg.keyword ) ASC 
			';
		}
		if(!$stmt = $mysqli->prepare($query)) 
			trigger_error("CumulativeKeywordsJSONResponse SQL error", E_USER_ERROR);
		
		$stmt->execute();
		$stmt->bind_result(
			$count, 
			$keyword
		);
		while($stmt->fetch()) { 
			array_push(
				$ret,
				array(
					"keyword" => $keyword,
					"count" => $count));
		}
		for($index=0; $index<count($ret); $index++) { 
			$ret[$index]["filetree"] = array();
			$query = '
				SELECT fti.filepath, fti.filetype
				FROM al_filetree_index fti
				JOIN al_keyword_cumulative_graph kcg ON kcg.filetreeid = fti.id
				WHERE kcg.keyword = ?
				
			';
			if(!$stmt = $mysqli->prepare($query)) 
				trigger_error("CumulativeKeywordsJSONResponse SQL error", E_USER_ERROR);
			$stmt->bind_param("s", $ret[$index]["keyword"]);
			$stmt->execute();
			$stmt->bind_result($filepath, $filetype);
			while($stmt->fetch()) { 
				array_push($ret[$index]["filetree"], array("filepath" => $filepath, "filetype" => $filetype));
			}
		}
		echo json_encode($ret);
		exit();
}
/* */ 
function SelectCumulativeKeywordsHTMLResponse($mysqli, $filterExpression = FALSE) {
		if(!$filterExpression) {
			$query = "
				SELECT DISTINCT id, keyword, count
				FROM al_keyword_cumulative_graph
			";
		}
		if(!$stmt = $mysqli->prepare($query)) 
			trigger_error("SelectCumulativeKeyowrdsHTMLResponse SQL Error", E_USER_ERROR);
		$stmt->execute();
		$stmt->bind_result(
			$keyword, 
			$count
		);
		while($stmt2->fetch()) { 
			// TODO echo HTML Table
		}
} 
/* TODO */
function GetKeywordID_Or_AddKeywordAndGetID($mysqli, $keyword) { 
	$id = 0;
	return $id;
}
/* TODO */
function CreateKeywordAndFileEntryLinkage($mysqli, $keywordid, $fileid) { 
}
/* TODO: for each keyword, select * from file tree index where like keyword, GetKeywordID_Or_AddKeywordAndGetID, then setup linkage. */
function StoreSelectedKeywords($mysqli, $selectedSetIDs) { 
	$query = "
		SELECT * from al_filetree_index
		WHERE filepath LIKE % ? %
	";	
}
/* */
function LibrarySortedByKeywordsJSONResponse(
	$mysqli,
	$filterExpression = FALSE) { 
		$ret = array();
		if(!$filterExpression) {
			$query = "
				SELECT fti.filepath, ftk.keyword
				FROM filepath fti 
				JOIN al_filetree_keyword_linkage ftkl ON fti.id = ftkl.filetree_id 
				JOIN al_filetree_keywords ftk ON ftk.id = ftkl.keyword_id
				ORDER BY ftk.keyword
			";
		}
		if(!$stmt = $mysqli->prepare($query)) 
			trigger_error("LibrarySortedByKeywordsJSONResponse SQL error", E_USER_ERROR);
		$stmt->execute();
		$stmt->bind_result(
			$filepath, 
			$keyword
		);
		while($stmt2->fetch()) { 
			array_push(
				$ret,
				array(
					"filepath" => $filepath,
					"keyword" => $keyword));
		}
		echo json_encode($ret);
		exit();
}
/* */
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html>
<head>
<script src="js/jquery-1.4.3.js"></script>
<script src="js/jquery-1.4.4.min.js"></script>
<script type="text/javascript" src="js/jquery.tablesorter.js"></script> 
<script type="text/javascript" src="js/jquery-ui-1.8.7.custom.min.js"></script> 
<!--link rel='stylesheet' type='text/css' href='css/sunny/jquery-ui-1.8.7.custom.css'/-->
<link rel='stylesheet' type='text/css' href='css/hot-sneaks/jquery-ui-1.8.7.custom.css'/>
<title>Ajaxian Ebook Library</title>
<script>
	$(document).ready(function() {
		$("#accordion").accordion({
			autoHeight: false,
			navigation: true
		});
	});
	$(document).ready(function() {
		$("#readertabs").tabs({
			closable: "all", //todo ???????
			load: function(event, ui) {
				SetWindowProportions();
			}
		});
	});
</script>
</head>
<body>
<script language="JavaScript">
	$(document).ready(function() { 
		GetEntireFileTreeLibrary();
		GetLibrarySortedByKeywords();
	});
	function GetEntireFileTreeProgress(a, b, c) {
		for(var index = 0; index < a.length; index++) {
		      // $("#everythinglist").append("<li><a href=\"" + a[index].filepath + "\">"+a[index].filepath+"</a></li>");	
		       $("#everythinglist").append("<li id=\""+a[index].id+"\" class=\""+ a[index].filetype+"\" style=\"cursor: pointer;\" onclick=\"AddReaderDivAndSetupViewer(this);\">" + a[index].filepath + "</li>");	
		}

	}
	function GetEntireFileTreeError(a, b, c) { 
		alert("get entire filetree broke");	
	}
	function GetLibrarySortedByKeywordsProgress(a, b, c) { 
		/*	<div id="accordion" class="myaccordion" style="width:250px;">
    			<h3><a href="#">Everything Unsorted</a></h3>
			<div class="accordionblock" style="font-size: 8pt; height:600px;">
			http://stackoverflow.com/questions/910645/add-items-to-a-jquery-accordion-with-jquery
		 */
		for(var index = 0; index < a.length; index++) {
		//	$("#accordion").append('<h3 class="ui-accordion-header ui-helper-reset ui-state-default ui-corner-all" ><a href="#">'+a[index].keyword+'"</a></h3><div class="accordionblock ui-accordion-content ui-helper-reset ui-widget-content ui-corner-bottom" style="font-size: 8pt; height:600px;"></div>');
			
		}

	}
	function GetLibrarySortedByKeywordsError(a, b, c) { 
		alert("fuck");
	}
	function GetEntireFileTreeLibrary() {
		$.ajax({ 
			url: "index.php?getEntireFileTree=yes",
			type: "GET", 
			dataType: "json",
			success: GetEntireFileTreeProgress,
			error: GetEntireFileTreeError,
		});
	}
	function GetLibrarySortedByKeywords() { 
		$.ajax({ 
			url: "index.php?getSortedFileTree=yes",
			type: "GET", 
			dataType: "json",
			success: GetLibrarySortedByKeywordsProgress,
			error: GetLibrarySortedByKeywordsError,
		});
	}
	function AddChmTab(a, b, c) { 
		for(var index = 0; index < a.length; index++) {
			//extractedChmDir
			$('#readertabs').tabs("add", "chm.php?bookid=" + a[index].extractedChmDir+"&bookname="+a[index].bookname, a[index].bookname);
			return;
		}
	}
	function extractAndSetupChmError(a, b, c) {
	       alert("chm broke");	
	}
	function AddReaderDivAndSetupViewer(file) { 
		var filen = file.childNodes[0].data;
		var splitfile = filen.split("/");
		var filetype = splitfile[splitfile.length-1].split(".")[splitfile[splitfile.length-1].split(".").length-1];
		if(filetype == "pdf") { 
			$('#readertabs').tabs("add", "book.php?bookid="+filen, filen.split("/")[filen.split("/").length-1].split(".")[0]);
		}
		else if(filetype == "chm") { 
			$.ajax({
				url: "index.php?extractAndSetupChm=yes",
				type: "GET",
				dataType: "json",
				data: { bookname: filen },
				success: AddChmTab,
				error: extractAndSetupChmError,
			});	
		}
		SetWindowProportions();
		return;
	}
	/*function AddCloseHandlersToTabs() { 
		var kids = $('#tablist').contents();
		for(var index=2; index<kids.length; index++) { 
		}	
	}*/
	function SetWindowProportions() { 
		var browserWidth = $(window).width();
		var browserHeight = $(window).height();
		$('#content').css("width", "" + browserWidth - 300 + "px");
		$('#readertabs').css("width", "" + browserWidth - 300 + "px");
		$('#content').css("height", "" + browserHeight - 50 + "px");
		$('#readertabs').css("height", "" + browserHeight - 50 + "px");
		$('.accordionblock').css("height", "" + browserHeight - 110 + "px");
		
		$('.chmiframe').css("height", "" + browserHeight - 100 + "px");
		$('.pdfembed').css("height", "" + browserHeight - 100 + "px");
		
		$('.chmiframe').css("width", "" + browserWidth - 320 + "px");
		$('.pdfembed').css("width", "" + browserWidth - 320 + "px");
	}

</script>
<div id="wrapper" class="wrapper">
	<div id="header" class="header">
	</div>
	<br style="clear: both;" />
	<div id="sidebar" class="sidebar" style="float: left;">
		<div id="accordion" class="myaccordion" style="width:250px;">
    			<h3><a href="#">Everything Unsorted</a></h3>
			<div class="accordionblock" style="font-size: 8pt; height:600px;">
			<ul id="everythinglist">
			</ul>
			</div>
			<h3><a href="#">About</a></h3>
			<div>
<a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/us/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/us/88x31.png" /></a><br /><span xmlns:dct="http://purl.org/dc/terms/" href="http://purl.org/dc/dcmitype/InteractiveResource" property="dct:title" rel="dct:type">Ajaxian Library</span> by <a xmlns:cc="http://creativecommons.org/ns#" href="http://www.github.com/paigeadele" property="cc:attributionName" rel="cc:attributionURL">Paige Adele Thompson</a> is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/us/">Creative Commons Attribution-ShareAlike 3.0 United States License</a>.<br />Based on a work at <a xmlns:dct="http://purl.org/dc/terms/" href="https://github.com/paigeadele/Ajaxian-Library" rel="dct:source">github.com</a>.<br />Permissions beyond the scope of this license may be available at <a xmlns:cc="http://creativecommons.org/ns#" href="paigeat@devel.ws" rel="cc:morePermissions">paigeat@devel.ws</a>.
			</div>
		</div>
		<script language="JavaScript">
				jQuery(document).ready(function() {
					$('.accordion .head').click(function() {
						$(this).next().toggle('slow');
							return false;
					}).next().hide();
					//$('#readertabs').resizable();
					$(window).resize(SetWindowProportions);
					SetWindowProportions();
				});


		</script>
	</div>
	<div id="contentwrapper" class="contentwrapper" style="float: left; margin-left:10px;">
		<div id="content" class="content">
			<div id="readertabs" class="tabs" style="width:1000px; height: 700px;">
				<ul id="tablist">
	        			<!--li><a href="#fragment-1"><span>One</span></a></li>
				        <li><a href="#fragment-2"><span>Two</span></a></li>
	        			<li><a href="#fragment-3"><span>Three</span></a></li-->
				</ul>
				<!--div id="fragment-1">
	       	 			<p>First tab is active by default:</p>
	        			<pre><code>$('#example').tabs();</code></pre>
	   			 </div>
	    			<div id="fragment-2">
					bla bla bla bla
    				</div>
				<div id="fragment-3">
					bla bla bla bla
				</div-->
			</div>
		</div>
	</div>
	<br style="clear: both;"/>
	<div id="footer" class="footer">
	</div>
</div>
</body>
</html>

